# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `sparse` Chapter.
"""

# NAG Copyright 2017-2019.

from ..base import utils

real_gen_basic_setup = utils._EngineState._get_symbol('f11bdf')
real_gen_basic_setup.restype = None
real_gen_basic_setup.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_STRING, # Input, precon(len=1).
    utils._BYREF_STRING, # Input, norm(len=1).
    utils._BYREF_STRING, # Input, weight(len=1).
    utils._BYREF_INT, # Input, iterm.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._BYREF_FLOAT64, # Input, anorm.
    utils._BYREF_FLOAT64, # Input, sigmax.
    utils._BYREF_INT, # Input, monit.
    utils._BYREF_INT, # Output, lwreq.
    utils._EngineFloat64ArrayType.c_type, # Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of precon.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of norm.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of weight.
)

real_gen_basic_solver = utils._EngineState._get_symbol('f11bef')
real_gen_basic_solver.restype = None
real_gen_basic_solver.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, u[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, v[*].
    utils._EngineFloat64ArrayType.c_type, # Input, wgt[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_gen_basic_diag = utils._EngineState._get_symbol('f11bff')
real_gen_basic_diag.restype = None
real_gen_basic_diag.argtypes = (
    utils._BYREF_INT, # Output, itn.
    utils._BYREF_FLOAT64, # Output, stplhs.
    utils._BYREF_FLOAT64, # Output, stprhs.
    utils._BYREF_FLOAT64, # Output, anorm.
    utils._BYREF_FLOAT64, # Output, sigmax.
    utils._EngineFloat64ArrayType.c_type, # Input, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_gen_basic_setup = utils._EngineState._get_symbol('f11brf')
complex_gen_basic_setup.restype = None
complex_gen_basic_setup.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_STRING, # Input, precon(len=1).
    utils._BYREF_STRING, # Input, norm(len=1).
    utils._BYREF_STRING, # Input, weight(len=1).
    utils._BYREF_INT, # Input, iterm.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._BYREF_FLOAT64, # Input, anorm.
    utils._BYREF_FLOAT64, # Input, sigmax.
    utils._BYREF_INT, # Input, monit.
    utils._BYREF_INT, # Output, lwreq.
    utils._EngineComplex128ArrayType.c_type, # Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of precon.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of norm.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of weight.
)

complex_gen_basic_solver = utils._EngineState._get_symbol('f11bsf')
complex_gen_basic_solver.restype = None
complex_gen_basic_solver.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, u[*].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, v[*].
    utils._EngineFloat64ArrayType.c_type, # Input, wgt[*].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_gen_basic_diag = utils._EngineState._get_symbol('f11btf')
complex_gen_basic_diag.restype = None
complex_gen_basic_diag.argtypes = (
    utils._BYREF_INT, # Output, itn.
    utils._BYREF_FLOAT64, # Output, stplhs.
    utils._BYREF_FLOAT64, # Output, stprhs.
    utils._BYREF_FLOAT64, # Output, anorm.
    utils._BYREF_FLOAT64, # Output, sigmax.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_gen_precon_ilu = utils._EngineState._get_symbol('f11daf')
real_gen_precon_ilu.restype = None
real_gen_precon_ilu.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input/Output, irow[la].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[la].
    utils._BYREF_INT, # Input, lfill.
    utils._BYREF_FLOAT64, # Input, dtol.
    utils._BYREF_STRING, # Input, pstrat(len=1).
    utils._BYREF_STRING, # Input, milu(len=1).
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[n].
    utils._EngineIntArrayType.c_type, # Output, istr[n+1].
    utils._EngineIntArrayType.c_type, # Output, idiag[n].
    utils._BYREF_INT, # Output, nnzc.
    utils._BYREF_INT, # Output, npivm.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of pstrat.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of milu.
)

real_gen_precon_ilu_solve = utils._EngineState._get_symbol('f11dbf')
real_gen_precon_ilu_solve.restype = None
real_gen_precon_ilu_solve.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[n].
    utils._EngineIntArrayType.c_type, # Input, istr[n+1].
    utils._EngineIntArrayType.c_type, # Input, idiag[n].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

real_gen_solve_ilu = utils._EngineState._get_symbol('f11dcf')
real_gen_solve_ilu.restype = None
real_gen_solve_ilu.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[n].
    utils._EngineIntArrayType.c_type, # Input, istr[n+1].
    utils._EngineIntArrayType.c_type, # Input, idiag[n].
    utils._EngineFloat64ArrayType.c_type, # Input, b[n].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
)

real_gen_precon_ssor_solve = utils._EngineState._get_symbol('f11ddf')
real_gen_precon_ssor_solve.restype = None
real_gen_precon_ssor_solve.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._EngineFloat64ArrayType.c_type, # Input, rdiag[n].
    utils._BYREF_FLOAT64, # Input, omega.
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[2*n+1].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

real_gen_solve_jacssor = utils._EngineState._get_symbol('f11def')
real_gen_solve_jacssor.restype = None
real_gen_solve_jacssor.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_STRING, # Input, precon(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_FLOAT64, # Input, omega.
    utils._EngineFloat64ArrayType.c_type, # Input, b[n].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[2*n+1].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of precon.
)

real_gen_precon_bdilu = utils._EngineState._get_symbol('f11dff')
real_gen_precon_bdilu.restype = None
real_gen_precon_bdilu.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input/Output, irow[la].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[la].
    utils._BYREF_INT, # Input, nb.
    utils._EngineIntArrayType.c_type, # Input, istb[nb+1].
    utils._EngineIntArrayType.c_type, # Input, indb[lindb].
    utils._BYREF_INT, # Input, lindb.
    utils._EngineIntArrayType.c_type, # Input, lfill[nb].
    utils._EngineFloat64ArrayType.c_type, # Input, dtol[nb].
    utils._EngineCharArrayType.c_type, # Input, pstrat(len=1)[nb].
    utils._EngineCharArrayType.c_type, # Input, milu(len=1)[nb].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[lindb].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[lindb].
    utils._EngineIntArrayType.c_type, # Output, istr[lindb+1].
    utils._EngineIntArrayType.c_type, # Output, idiag[lindb].
    utils._BYREF_INT, # Output, nnzc.
    utils._EngineIntArrayType.c_type, # Output, npivm[nb].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of pstrat.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of milu.
)

real_gen_solve_bdilu = utils._EngineState._get_symbol('f11dgf')
real_gen_solve_bdilu.restype = None
real_gen_solve_bdilu.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._BYREF_INT, # Input, nb.
    utils._EngineIntArrayType.c_type, # Input, istb[nb+1].
    utils._EngineIntArrayType.c_type, # Input, indb[lindb].
    utils._BYREF_INT, # Input, lindb.
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[lindb].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[lindb].
    utils._EngineIntArrayType.c_type, # Input, istr[lindb+1].
    utils._EngineIntArrayType.c_type, # Input, idiag[lindb].
    utils._EngineFloat64ArrayType.c_type, # Input, b[n].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
)

real_gen_precon_jacobi = utils._EngineState._get_symbol('f11dkf')
real_gen_precon_jacobi.restype = None
real_gen_precon_jacobi.argtypes = (
    utils._BYREF_STRING, # Input, store(len=1).
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_STRING, # Input, init(len=1).
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input, b[n].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, diag[n].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of store.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of init.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

complex_gen_precon_ilu = utils._EngineState._get_symbol('f11dnf')
complex_gen_precon_ilu.restype = None
complex_gen_precon_ilu.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input/Output, irow[la].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[la].
    utils._BYREF_INT, # Input, lfill.
    utils._BYREF_FLOAT64, # Input, dtol.
    utils._BYREF_STRING, # Input, pstrat(len=1).
    utils._BYREF_STRING, # Input, milu(len=1).
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[n].
    utils._EngineIntArrayType.c_type, # Output, istr[n+1].
    utils._EngineIntArrayType.c_type, # Output, idiag[n].
    utils._BYREF_INT, # Output, nnzc.
    utils._BYREF_INT, # Output, npivm.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of pstrat.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of milu.
)

complex_gen_precon_ilu_solve = utils._EngineState._get_symbol('f11dpf')
complex_gen_precon_ilu_solve.restype = None
complex_gen_precon_ilu_solve.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._EngineComplex128ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[n].
    utils._EngineIntArrayType.c_type, # Input, istr[n+1].
    utils._EngineIntArrayType.c_type, # Input, idiag[n].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineComplex128ArrayType.c_type, # Input, y[n].
    utils._EngineComplex128ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

complex_gen_solve_ilu = utils._EngineState._get_symbol('f11dqf')
complex_gen_solve_ilu.restype = None
complex_gen_solve_ilu.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[n].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[n].
    utils._EngineIntArrayType.c_type, # Input, istr[n+1].
    utils._EngineIntArrayType.c_type, # Input, idiag[n].
    utils._EngineComplex128ArrayType.c_type, # Input, b[n].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineComplex128ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
)

complex_gen_precon_ssor_solve = utils._EngineState._get_symbol('f11drf')
complex_gen_precon_ssor_solve.restype = None
complex_gen_precon_ssor_solve.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._EngineComplex128ArrayType.c_type, # Input, rdiag[n].
    utils._BYREF_FLOAT64, # Input, omega.
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineComplex128ArrayType.c_type, # Input, y[n].
    utils._EngineComplex128ArrayType.c_type, # Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[2*n+1].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

complex_gen_solve_jacssor = utils._EngineState._get_symbol('f11dsf')
complex_gen_solve_jacssor.restype = None
complex_gen_solve_jacssor.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_STRING, # Input, precon(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_FLOAT64, # Input, omega.
    utils._EngineComplex128ArrayType.c_type, # Input, b[n].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineComplex128ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[2*n+1].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of precon.
)

complex_gen_precon_bdilu = utils._EngineState._get_symbol('f11dtf')
complex_gen_precon_bdilu.restype = None
complex_gen_precon_bdilu.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input/Output, irow[la].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[la].
    utils._BYREF_INT, # Input, nb.
    utils._EngineIntArrayType.c_type, # Input, istb[nb+1].
    utils._EngineIntArrayType.c_type, # Input, indb[lindb].
    utils._BYREF_INT, # Input, lindb.
    utils._EngineIntArrayType.c_type, # Input, lfill[nb].
    utils._EngineFloat64ArrayType.c_type, # Input, dtol[nb].
    utils._EngineCharArrayType.c_type, # Input, pstrat(len=1)[nb].
    utils._EngineCharArrayType.c_type, # Input, milu(len=1)[nb].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[lindb].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[lindb].
    utils._EngineIntArrayType.c_type, # Output, istr[lindb+1].
    utils._EngineIntArrayType.c_type, # Output, idiag[lindb].
    utils._BYREF_INT, # Output, nnzc.
    utils._EngineIntArrayType.c_type, # Output, npivm[nb].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of pstrat.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of milu.
)

complex_gen_solve_bdilu = utils._EngineState._get_symbol('f11duf')
complex_gen_solve_bdilu.restype = None
complex_gen_solve_bdilu.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._BYREF_INT, # Input, nb.
    utils._EngineIntArrayType.c_type, # Input, istb[nb+1].
    utils._EngineIntArrayType.c_type, # Input, indb[lindb].
    utils._BYREF_INT, # Input, lindb.
    utils._EngineIntArrayType.c_type, # Input/Output, ipivp[lindb].
    utils._EngineIntArrayType.c_type, # Input/Output, ipivq[lindb].
    utils._EngineIntArrayType.c_type, # Input, istr[lindb+1].
    utils._EngineIntArrayType.c_type, # Input, idiag[lindb].
    utils._EngineComplex128ArrayType.c_type, # Input, b[n].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineComplex128ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
)

complex_gen_precon_jacobi = utils._EngineState._get_symbol('f11dxf')
complex_gen_precon_jacobi.restype = None
complex_gen_precon_jacobi.argtypes = (
    utils._BYREF_STRING, # Input, store(len=1).
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_STRING, # Input, init(len=1).
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineComplex128ArrayType.c_type, # Input, b[n].
    utils._EngineComplex128ArrayType.c_type, # Output, x[n].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, diag[n].
    utils._EngineComplex128ArrayType.c_type, # Workspace, work[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of store.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of init.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

real_symm_basic_setup = utils._EngineState._get_symbol('f11gdf')
real_symm_basic_setup.restype = None
real_symm_basic_setup.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_STRING, # Input, precon(len=1).
    utils._BYREF_STRING, # Input, sigcmp(len=1).
    utils._BYREF_STRING, # Input, norm(len=1).
    utils._BYREF_STRING, # Input, weight(len=1).
    utils._BYREF_INT, # Input, iterm.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._BYREF_FLOAT64, # Input, anorm.
    utils._BYREF_FLOAT64, # Input, sigmax.
    utils._BYREF_FLOAT64, # Input, sigtol.
    utils._BYREF_INT, # Input, maxits.
    utils._BYREF_INT, # Input, monit.
    utils._BYREF_INT, # Output, lwreq.
    utils._EngineFloat64ArrayType.c_type, # Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of precon.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of sigcmp.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of norm.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of weight.
)

real_symm_basic_solver = utils._EngineState._get_symbol('f11gef')
real_symm_basic_solver.restype = None
real_symm_basic_solver.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, u[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, v[*].
    utils._EngineFloat64ArrayType.c_type, # Input, wgt[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_symm_basic_diag = utils._EngineState._get_symbol('f11gff')
real_symm_basic_diag.restype = None
real_symm_basic_diag.argtypes = (
    utils._BYREF_INT, # Output, itn.
    utils._BYREF_FLOAT64, # Output, stplhs.
    utils._BYREF_FLOAT64, # Output, stprhs.
    utils._BYREF_FLOAT64, # Output, anorm.
    utils._BYREF_FLOAT64, # Output, sigmax.
    utils._BYREF_INT, # Output, its.
    utils._BYREF_FLOAT64, # Output, sigerr.
    utils._EngineFloat64ArrayType.c_type, # Input, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_herm_basic_setup = utils._EngineState._get_symbol('f11grf')
complex_herm_basic_setup.restype = None
complex_herm_basic_setup.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_STRING, # Input, precon(len=1).
    utils._BYREF_STRING, # Input, sigcmp(len=1).
    utils._BYREF_STRING, # Input, norm(len=1).
    utils._BYREF_STRING, # Input, weight(len=1).
    utils._BYREF_INT, # Input, iterm.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._BYREF_FLOAT64, # Input, anorm.
    utils._BYREF_FLOAT64, # Input, sigmax.
    utils._BYREF_FLOAT64, # Input, sigtol.
    utils._BYREF_INT, # Input, maxits.
    utils._BYREF_INT, # Input, monit.
    utils._BYREF_INT, # Output, lwreq.
    utils._EngineComplex128ArrayType.c_type, # Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of precon.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of sigcmp.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of norm.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of weight.
)

complex_herm_basic_solver = utils._EngineState._get_symbol('f11gsf')
complex_herm_basic_solver.restype = None
complex_herm_basic_solver.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, u[*].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, v[*].
    utils._EngineFloat64ArrayType.c_type, # Input, wgt[*].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_herm_basic_diag = utils._EngineState._get_symbol('f11gtf')
complex_herm_basic_diag.restype = None
complex_herm_basic_diag.argtypes = (
    utils._BYREF_INT, # Output, itn.
    utils._BYREF_FLOAT64, # Output, stplhs.
    utils._BYREF_FLOAT64, # Output, stprhs.
    utils._BYREF_FLOAT64, # Output, anorm.
    utils._BYREF_FLOAT64, # Output, sigmax.
    utils._BYREF_INT, # Output, its.
    utils._BYREF_FLOAT64, # Output, sigerr.
    utils._EngineComplex128ArrayType.c_type, # Input, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_symm_precon_ichol = utils._EngineState._get_symbol('f11jaf')
real_symm_precon_ichol.restype = None
real_symm_precon_ichol.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input/Output, irow[la].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[la].
    utils._BYREF_INT, # Input, lfill.
    utils._BYREF_FLOAT64, # Input, dtol.
    utils._BYREF_STRING, # Input, mic(len=1).
    utils._BYREF_FLOAT64, # Input, dscale.
    utils._BYREF_STRING, # Input, pstrat(len=1).
    utils._EngineIntArrayType.c_type, # Input/Output, ipiv[n].
    utils._EngineIntArrayType.c_type, # Output, istr[n+1].
    utils._BYREF_INT, # Output, nnzc.
    utils._BYREF_INT, # Output, npivm.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of mic.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of pstrat.
)

real_symm_precon_ichol_solve = utils._EngineState._get_symbol('f11jbf')
real_symm_precon_ichol_solve.restype = None
real_symm_precon_ichol_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._EngineIntArrayType.c_type, # Input/Output, ipiv[n].
    utils._EngineIntArrayType.c_type, # Input, istr[n+1].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

real_symm_solve_ichol = utils._EngineState._get_symbol('f11jcf')
real_symm_solve_ichol.restype = None
real_symm_solve_ichol.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._EngineIntArrayType.c_type, # Input/Output, ipiv[n].
    utils._EngineIntArrayType.c_type, # Input, istr[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input, b[n].
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
)

real_symm_precon_ssor_solve = utils._EngineState._get_symbol('f11jdf')
real_symm_precon_ssor_solve.restype = None
real_symm_precon_ssor_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._EngineFloat64ArrayType.c_type, # Input, rdiag[n].
    utils._BYREF_FLOAT64, # Input, omega.
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n+1].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

real_symm_solve_jacssor = utils._EngineState._get_symbol('f11jef')
real_symm_solve_jacssor.restype = None
real_symm_solve_jacssor.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_STRING, # Input, precon(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_FLOAT64, # Input, omega.
    utils._EngineFloat64ArrayType.c_type, # Input, b[n].
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n+1].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of precon.
)

complex_herm_precon_ichol = utils._EngineState._get_symbol('f11jnf')
complex_herm_precon_ichol.restype = None
complex_herm_precon_ichol.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input/Output, irow[la].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[la].
    utils._BYREF_INT, # Input, lfill.
    utils._BYREF_FLOAT64, # Input, dtol.
    utils._BYREF_STRING, # Input, mic(len=1).
    utils._BYREF_FLOAT64, # Input, dscale.
    utils._BYREF_STRING, # Input, pstrat(len=1).
    utils._EngineIntArrayType.c_type, # Input/Output, ipiv[n].
    utils._EngineIntArrayType.c_type, # Output, istr[n+1].
    utils._BYREF_INT, # Output, nnzc.
    utils._BYREF_INT, # Output, npivm.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of mic.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of pstrat.
)

complex_herm_precon_ilu_solve = utils._EngineState._get_symbol('f11jpf')
complex_herm_precon_ilu_solve.restype = None
complex_herm_precon_ilu_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineComplex128ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._EngineIntArrayType.c_type, # Input/Output, ipiv[n].
    utils._EngineIntArrayType.c_type, # Input, istr[n+1].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineComplex128ArrayType.c_type, # Input, y[n].
    utils._EngineComplex128ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

complex_herm_solve_ilu = utils._EngineState._get_symbol('f11jqf')
complex_herm_solve_ilu.restype = None
complex_herm_solve_ilu.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, irow[la].
    utils._EngineIntArrayType.c_type, # Input, icol[la].
    utils._EngineIntArrayType.c_type, # Input/Output, ipiv[n].
    utils._EngineIntArrayType.c_type, # Input, istr[n+1].
    utils._EngineComplex128ArrayType.c_type, # Input, b[n].
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineComplex128ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
)

complex_herm_precon_ssor_solve = utils._EngineState._get_symbol('f11jrf')
complex_herm_precon_ssor_solve.restype = None
complex_herm_precon_ssor_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._EngineFloat64ArrayType.c_type, # Input, rdiag[n].
    utils._BYREF_FLOAT64, # Input, omega.
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineComplex128ArrayType.c_type, # Input, y[n].
    utils._EngineComplex128ArrayType.c_type, # Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n+1].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

complex_herm_solve_jacssor = utils._EngineState._get_symbol('f11jsf')
complex_herm_solve_jacssor.restype = None
complex_herm_solve_jacssor.argtypes = (
    utils._BYREF_STRING, # Input, method(len=*).
    utils._BYREF_STRING, # Input, precon(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_FLOAT64, # Input, omega.
    utils._EngineComplex128ArrayType.c_type, # Input, b[n].
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxitn.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, itn.
    utils._EngineFloat64ArrayType.c_type, # Output, rdiag[n].
    utils._EngineComplex128ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n+1].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of precon.
)

direct_real_gen_setup = utils._EngineState._get_symbol('f11mdf')
direct_real_gen_setup.restype = None
direct_real_gen_setup.argtypes = (
    utils._BYREF_STRING, # Input, spec(len=1).
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, icolzp[max(1, (n+1))].
    utils._EngineIntArrayType.c_type, # Input, irowix[max(1, (icolzp[max(1, (n+1))]-1))].
    utils._EngineIntArrayType.c_type, # Input/Output, iprm[max(1, (7*n))].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of spec.
)

direct_real_gen_lu = utils._EngineState._get_symbol('f11mef')
direct_real_gen_lu.restype = None
direct_real_gen_lu.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, irowix[*].
    utils._EngineFloat64ArrayType.c_type, # Input, a[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iprm[7*n].
    utils._BYREF_FLOAT64, # Input, thresh.
    utils._BYREF_INT, # Input, nzlmx.
    utils._BYREF_INT, # Input/Output, nzlumx.
    utils._BYREF_INT, # Input, nzumx.
    utils._EngineIntArrayType.c_type, # Output, il[7*n+nzlmx+4].
    utils._EngineFloat64ArrayType.c_type, # Output, lval[nzlumx].
    utils._EngineIntArrayType.c_type, # Output, iu[2*n+nzumx+1].
    utils._EngineFloat64ArrayType.c_type, # Output, uval[nzumx].
    utils._BYREF_INT, # Output, nnzl.
    utils._BYREF_INT, # Output, nnzu.
    utils._BYREF_FLOAT64, # Output, flop.
    utils._BYREF_INT, # Input/Output, ifail.
)

direct_real_gen_solve = utils._EngineState._get_symbol('f11mff')
direct_real_gen_solve.restype = None
direct_real_gen_solve.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, iprm[7*n].
    utils._EngineIntArrayType.c_type, # Input, il[*].
    utils._EngineFloat64ArrayType.c_type, # Input, lval[*].
    utils._EngineIntArrayType.c_type, # Input, iu[*].
    utils._EngineFloat64ArrayType.c_type, # Input, uval[*].
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
)

direct_real_gen_cond = utils._EngineState._get_symbol('f11mgf')
direct_real_gen_cond.restype = None
direct_real_gen_cond.argtypes = (
    utils._BYREF_STRING, # Input, norm(len=1).
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, il[*].
    utils._EngineFloat64ArrayType.c_type, # Input, lval[*].
    utils._EngineIntArrayType.c_type, # Input, iu[*].
    utils._EngineFloat64ArrayType.c_type, # Input, uval[*].
    utils._BYREF_FLOAT64, # Input, anorm.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of norm.
)

direct_real_gen_refine = utils._EngineState._get_symbol('f11mhf')
direct_real_gen_refine.restype = None
direct_real_gen_refine.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, icolzp[*].
    utils._EngineIntArrayType.c_type, # Input, irowix[*].
    utils._EngineFloat64ArrayType.c_type, # Input, a[*].
    utils._EngineIntArrayType.c_type, # Input, iprm[7*n].
    utils._EngineIntArrayType.c_type, # Input, il[*].
    utils._EngineFloat64ArrayType.c_type, # Input, lval[*].
    utils._EngineIntArrayType.c_type, # Input, iu[*].
    utils._EngineFloat64ArrayType.c_type, # Input, uval[*].
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._EngineFloat64ArrayType.c_type, # Output, ferr[nrhs].
    utils._EngineFloat64ArrayType.c_type, # Output, berr[nrhs].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
)

direct_real_gen_matmul = utils._EngineState._get_symbol('f11mkf')
direct_real_gen_matmul.restype = None
direct_real_gen_matmul.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, alpha.
    utils._EngineIntArrayType.c_type, # Input, icolzp[*].
    utils._EngineIntArrayType.c_type, # Input, irowix[*].
    utils._EngineFloat64ArrayType.c_type, # Input, a[*].
    utils._EngineFloat64ArrayType.c_type, # Input, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Input, beta.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[ldc, *].
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
)

direct_real_gen_norm = utils._EngineState._get_symbol('f11mlf')
direct_real_gen_norm.restype = None
direct_real_gen_norm.argtypes = (
    utils._BYREF_STRING, # Input, norm(len=1).
    utils._BYREF_FLOAT64, # Output, anorm.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, icolzp[*].
    utils._EngineIntArrayType.c_type, # Input, irowix[*].
    utils._EngineFloat64ArrayType.c_type, # Input, a[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of norm.
)

direct_real_gen_diag = utils._EngineState._get_symbol('f11mmf')
direct_real_gen_diag.restype = None
direct_real_gen_diag.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, icolzp[*].
    utils._EngineFloat64ArrayType.c_type, # Input, a[*].
    utils._EngineIntArrayType.c_type, # Input, iprm[7*n].
    utils._EngineIntArrayType.c_type, # Input, il[*].
    utils._EngineFloat64ArrayType.c_type, # Input, lval[*].
    utils._EngineIntArrayType.c_type, # Input, iu[*].
    utils._EngineFloat64ArrayType.c_type, # Input, uval[*].
    utils._BYREF_FLOAT64, # Output, rpg.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_gen_matvec = utils._EngineState._get_symbol('f11xaf')
real_gen_matvec.restype = None
real_gen_matvec.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, y[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

real_symm_matvec = utils._EngineState._get_symbol('f11xef')
real_symm_matvec.restype = None
real_symm_matvec.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, y[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

complex_gen_matvec = utils._EngineState._get_symbol('f11xnf')
complex_gen_matvec.restype = None
complex_gen_matvec.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineComplex128ArrayType.c_type, # Input, x[n].
    utils._EngineComplex128ArrayType.c_type, # Output, y[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

complex_herm_matvec = utils._EngineState._get_symbol('f11xsf')
complex_herm_matvec.restype = None
complex_herm_matvec.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_STRING, # Input, check(len=1).
    utils._EngineComplex128ArrayType.c_type, # Input, x[n].
    utils._EngineComplex128ArrayType.c_type, # Output, y[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of check.
)

sym_rcm = utils._EngineState._get_symbol('f11yef')
sym_rcm.restype = None
sym_rcm.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineIntArrayType.c_type, # Input, icolzp[n+1].
    utils._EngineIntArrayType.c_type, # Input, irowix[nnz].
    utils._EngineLogicalArrayType.c_type, # Input, lopts[5].
    utils._EngineIntArrayType.c_type, # Input, mask[*].
    utils._EngineIntArrayType.c_type, # Output, perm[n].
    utils._EngineIntArrayType.c_type, # Output, info[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

real_gen_sort = utils._EngineState._get_symbol('f11zaf')
real_gen_sort.restype = None
real_gen_sort.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input/Output, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[*].
    utils._EngineIntArrayType.c_type, # Input/Output, irow[*].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[*].
    utils._BYREF_STRING, # Input, dup(len=1).
    utils._BYREF_STRING, # Input, zer(len=1).
    utils._EngineIntArrayType.c_type, # Output, istr[n+1].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of dup.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of zer.
)

real_symm_sort = utils._EngineState._get_symbol('f11zbf')
real_symm_sort.restype = None
real_symm_sort.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input/Output, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[*].
    utils._EngineIntArrayType.c_type, # Input/Output, irow[*].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[*].
    utils._BYREF_STRING, # Input, dup(len=1).
    utils._BYREF_STRING, # Input, zer(len=1).
    utils._EngineIntArrayType.c_type, # Output, istr[n+1].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of dup.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of zer.
)

real_rect_sort = utils._EngineState._get_symbol('f11zcf')
real_rect_sort.restype = None
real_rect_sort.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input/Output, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[nnz].
    utils._EngineIntArrayType.c_type, # Input/Output, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[nnz].
    utils._EngineIntArrayType.c_type, # Input/Output, istc[n+1].
    utils._BYREF_INT, # Input, store.
    utils._BYREF_STRING, # Input, dup(len=1).
    utils._BYREF_STRING, # Input, zer(len=1).
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of dup.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of zer.
)

complex_gen_sort = utils._EngineState._get_symbol('f11znf')
complex_gen_sort.restype = None
complex_gen_sort.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input/Output, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, a[*].
    utils._EngineIntArrayType.c_type, # Input/Output, irow[*].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[*].
    utils._BYREF_STRING, # Input, dup(len=1).
    utils._BYREF_STRING, # Input, zer(len=1).
    utils._EngineIntArrayType.c_type, # Output, istr[n+1].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of dup.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of zer.
)

complex_herm_sort = utils._EngineState._get_symbol('f11zpf')
complex_herm_sort.restype = None
complex_herm_sort.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input/Output, nnz.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, a[*].
    utils._EngineIntArrayType.c_type, # Input/Output, irow[*].
    utils._EngineIntArrayType.c_type, # Input/Output, icol[*].
    utils._BYREF_STRING, # Input, dup(len=1).
    utils._BYREF_STRING, # Input, zer(len=1).
    utils._EngineIntArrayType.c_type, # Output, istr[n+1].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of dup.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of zer.
)
