# -*- coding: utf-8 -*-
u"""
Examples for the ``lapacklin`` module.

``lapacklin`` - Linear Equations (LAPACK)

This module provides functions for the solution of systems of
simultaneous linear equations, and associated computations.
It provides functions for

- matrix factorizations;

- solution of linear equations;

- estimating matrix condition numbers;

- computing error bounds for the solution of linear equations;

- matrix inversion;

- computing scaling factors to equilibrate a matrix.

Functions are provided for both real and complex data.

For a general introduction to the solution of systems of linear
equations, you should turn first to [the F04 Introduction].
The decision trees, in [the F04 Introduction], direct you to the most
appropriate functions in submodule ``linsys`` or submodule ``lapacklin``
for solving your particular problem.
In particular, submodule ``linsys`` and submodule ``lapacklin`` contain
Black Box (or driver) functions which enable some standard types of
problem to be solved by a call to a single function.
Where possible, functions in submodule ``linsys`` call submodule
``lapacklin`` functions to perform the necessary computational tasks.

There are two types of driver functions in this module: simple drivers
which just return the solution to the linear equations; and expert
drivers which also return condition and error estimates and, in many
cases, also allow equilibration.
The simple drivers for real matrices have names of the form and for
complex matrices have names of the form The expert drivers for real
matrices have names of the form and for complex matrices have names of
the form

The functions in this module (submodule ``lapacklin``) handle only dense
and band matrices (not matrices with more specialised structures, or
general sparse matrices).

The functions in this module have all been derived from the LAPACK
project.
They have been designed to be efficient on a wide range of
high-performance computers, without compromising efficiency on
conventional serial machines.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/f07/f07intro.html
"""

# NAG Copyright 2017-2019.

pass
