# -*- coding: utf-8 -*-
u"""
Examples for the ``linsys`` module.

``linsys`` - Simultaneous Linear Equations

This module is concerned with the solution of the matrix equation AX =
B, where B may be a single vector or a matrix of multiple right-hand
sides.
The matrix A may be real, complex, symmetric, Hermitian, positive
definite, positive definite Toeplitz or banded.
It may also be rectangular, in which case a least squares solution is
obtained.

Much of the functionality of this module has been superseded by
functions from submodule ``lapacklin`` and submodule ``lapackeig``
(LAPACK routines) as those modules have grown and have included driver
and expert driver functions.

For a general introduction to sparse systems of equations, see [the F11
Introduction], which provides functions for large sparse systems. Some
functions for sparse problems are also included in this module; they are
described in [Sparse Matrix Functions].

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/f04/f04intro.html
"""

# NAG Copyright 2017-2019.

pass
