# -*- coding: utf-8 -*-
u"""
Examples for the ``wav`` module.

``wav`` - Wavelet Transforms

This module is concerned with the analysis of datasets (or functions or
operators) in terms of frequency and scale components using wavelet
transforms.
Wavelet transforms have been applied in many fields from time series
analysis to image processing and the localization in either frequency or
scale that they provide is useful for data compression or denoising.
In general the standard wavelet transform uses dilation and scaling of a
chosen function, psi(t), (called the mother wavelet) such that

    psi_{a,b}(t) = 1/(sqrt(a))psi((t-b)/a)

where a gives the scaling and b determines the translation.
Wavelet methods can be divided into continuous transforms and discrete
transforms.
In the continuous case, the pair a and b are real numbers with a>0.
For the discrete transform, a and b can be chosen as a = 2^(-j), b =
k2^(-j) for integers j, k

    psi_{j,k}(t) = 2^(j/2)psi(2^jt-k).

The continuous real valued, one-dimensional wavelet transform (CWT) is
included in this module.
The discrete wavelet transform (DWT) at a single level together with its
inverse and the multi-level DWT with inverse are also provided for one,
two and three dimensions.
The Maximal Overlap DWT (MODWT) together with its inverse and the
multi-level MODWT with inverse are provided for one dimension.
The choice of wavelet for CWT includes the Morlet wavelet and
derivatives of a Gaussian while the DWT and MODWT offer the orthogonal
wavelets of Daubechies and a selection of biorthogonal wavelets.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/c09/c09intro.html
"""

# NAG Copyright 2017-2019.

pass
